<script setup lang="ts">

import {StaffFilterOptionModel} from "@/models/staff-filter-option.model";
import {ref, watch} from "vue";
import {useRoute, useRouter} from "vue-router";
import {useStaffStore} from "@/composable/useStaff";
import {storeToRefs} from "pinia";
import {StaffFilter} from "@/models/staff-filter";
import {useLaravelError} from "@/composable/useLaravelError";

const filterOptions: StaffFilterOptionModel[] = [
    {
        title: 'Количество пользователей с заданным именем',
        value: 'filter_name_count'
    },
    {
        title: 'Вывод самых популярных имен с указанием количества пользователей',
        value: 'filter_name_popular'
    },
    {
        title: 'Средний возраст',
        value: 'filter_avg_age'
    },
    {
        title: 'Количество пользователей, возраст которых в заданном диапазоне',
        value: 'filter_age_count'
    },
]

const timerStaff = ref<any>(null)

const filterStaff = ref<StaffFilter>({
    type: filterOptions[0].value,
})

const loadingFetch = ref<boolean>()
const error = ref()

const router = useRouter()
const route = useRoute()

const staffStore = useStaffStore()
const {staffData} = storeToRefs(staffStore)


const filterDataFetch = () => {
    if (!checkFormParams()) return

    setLoading(true)
    setError('')


    if (timerStaff.value) {
        clearTimeout(timerStaff.value);
        timerStaff.value = null;
    }

    timerStaff.value = setTimeout(() => {
        staffStore.fetchStaffFilter({
            filter: filterStaff.value
        })
            .catch(err => {
                setError(useLaravelError(err))
            })
            .finally(() => {
                setLoading(false)
            })

    }, 800);
}

const setLoading = (loading: boolean) => {
    loadingFetch.value = loading
}

const setError = (err: any) => {
    error.value = err
}

const checkFormParams = () => {
    if (filterStaff.value.type === 'filter_age_count') {
        if (!filterStaff.value.age_min || !filterStaff.value.age_max) return false;
    } else if (filterStaff.value.type === 'filter_name_count') {
        if (!filterStaff.value.query) return false;
    }
    return true;
}

const checkResetFormOrRoute = () => {
    staffData.value = []
    filterDataFetch()
}

watch(filterStaff, () => {
    router.replace({query: filterStaff.value});
    checkResetFormOrRoute()
}, {deep: true});

watch(
    () => route.query,
    (newQuery) => {
        filterStaff.value.type = newQuery.type?.toString() || filterOptions[0].value;

        filterStaff.value.age_min = null
        filterStaff.value.age_max = null
        filterStaff.value.query = null


        if (filterStaff.value.type === 'filter_age_count') {
            filterStaff.value.age_min = newQuery.age_min ? parseInt(newQuery.age_min.toString()) : null;
            filterStaff.value.age_max = newQuery.age_max ? parseInt(newQuery.age_max.toString()) : null;
        } else if (filterStaff.value.type === 'filter_name_count') {
            filterStaff.value.query = newQuery.query?.toString() || null;
        }

    },
    {immediate: true}
);

</script>

<template>
    <div class="container">
        <div class="box">
            <select class="form-select" v-model="filterStaff.type">
                <option v-for="option in filterOptions" :key="option.value" :value="option.value">
                    {{ option.title }}
                </option>
            </select>

            <div v-if="filterStaff.type === 'filter_name_count'">
                <label>Поиск: </label>
                <input required class="form-control" type="text" v-model="filterStaff.query"/>
            </div>
            <div class="box" v-if="filterStaff.type === 'filter_age_count'">
                <div>
                    <label>Возраст от: </label>
                    <input required class="form-control" type="number" min="1" max="100" v-model="filterStaff.age_min"/>
                </div>
                <div>
                    <label>Возраст до: </label>
                    <input required class="form-control" type="number" min="1" max="100" v-model="filterStaff.age_max"/>
                </div>
            </div>
        </div>

        <div class="box" v-if="loadingFetch">
            Загрузка...
        </div>
        <div v-else-if="!error && staffData?.data != null">
            <div class="box"
                 v-if="['filter_name_count','filter_avg_age','filter_age_count'].includes(filterStaff.type)">
                <span>Ответ: {{ staffData.data }}</span>
            </div>
            <div class="box column" v-if="['filter_name_popular'].includes(filterStaff.type)">
                <span v-for="staff in staffData.data">
                    Имя: {{staff.first_name}} - Количество: {{staff.count}}
                </span>
            </div>
        </div>

        <div class="box" v-if="error">
            Ошибка: {{ error }}
        </div>
    </div>
</template>

<style scoped>

</style>
